#!/usr/local/bin/perl
local($nextline);
sub getnextline
{
    $nextline=<>;
    if($nextline eq ""){
	return 0;
    }else{
	return 1;
    }
}
sub getonetcpdata
{
    local(*ipproto,*fromhost,*fromport,*tohost,*toport,*size)=@_;
    if($nextline eq ""){
	if(! &getnextline){return 0;}
    }
    $ipproto="none";
    $fromhost="";
    $tohost="";
    $fromport=0;
    $toport=0;
    $size=0;

    if($nextline =~ /^(\d\d):(\d\d):(\d\d)\.(\d+) arp (\S+) ([^\s\:]+) tell ([^\s\:]+)/){
	$ipproto="arp";
	$fromhost=$6;
	$fromport=$5;
	$tohost=$7;
   }elsif($nextline =~ /^(\d\d):(\d\d):(\d\d)\.(\d+) ([^\s\:]+) > ([^\s\:]+):/){
	$lost=$';
	$fromhost=$5;
	$tohost=$6;

	$ipproto='tcp';
	if($lost=~/^ (tcp|udp|icmp)/){
	    $ipproto=$1;
	}
	if($ipproto =~ /^(tcp|udp)$/){
	    
	    if($fromhost !~ /^\d+\.\d+\.\d+\.\d+$/ 
	       && $fromhost =~ /^(.+)\.([^\.]+)/){
		$fromhost=$1;
		$fromport=$2;
	    }
	    if($tohost !~ /^\d\.\d\.\d\.\d$/
	       && $tohost =~ /^(.+)\.([^\.]+)/){
		$tohost=$1;
		$toport=$2;
	    }
	}
	if($lost =~ /nfs/){
	    $toport="nfs";
	}

    }else{
	$ipproto="other";
    }
   $size=0;
    while(1){
	&getnextline;
	if($nextline =~ /^\s+[0-9a-z]+\s+([0-9a-z]+)\s+/){
	    if($size==0){
		$size=hex($1);
	    }
	}else{
	    return 1;
	}
    }
}

#main
{
    $|=1;
    $ret=1;
    while($ret==1){
	$ret=&getonetcpdata(*ipproto,*fromhost,*fromport,*tohost,*toport,*size);
	print "$ipproto,$fromhost,$fromport,$tohost,$toport,$size\n";
    }
    print STDERR "End of file!\n";
}







